%define ver      5.0r12

%define ma_realversion 1.2.12
%define qb_realversion 1.2.12
%define mt_realversion 1.1.12alpha

%define build_mt 1

%define sles9	%(if [ -e /etc/SuSE-release ] && grep -q "SUSE LINUX Enterprise Server 9" /etc/SuSE-release; then echo 1; else echo 0; fi; )
%define suse10	%(if [ -e /etc/SuSE-release ] && grep -q "LINUX 10" /etc/SuSE-release; then echo 1; else echo 0; fi; )
%define rhel4	%(if [ -e /etc/redhat-release ] && grep -q "release 4" /etc/redhat-release; then echo 1; else echo 0; fi; )
%define rhel3	%(if [ -e /etc/redhat-release ] && grep -q "release 3" /etc/redhat-release; then echo 1; else echo 0; fi; )
%define fc5	%(if [ -e /etc/fedora-release ] && grep -q "release 5" /etc/fedora-release; then echo 1; else echo 0; fi; )


%define jarch %(echo %{_arch} | sed -e s/x86_64/amd64/ -e s/i.86/i386/)

%define javaincdir /usr/java/jdk1.6.0/include/ 
%define javalibdir /usr/java/jdk1.6.0/jre/lib/%{jarch}/server

%define gcc3 0
%define suse 0

%if %{sles9}
%define rel	1sles9
%define gtkhtml  libgtkhtml-2.0
%define bundledeps 1
%define	suse	1
%endif
%if %{suse10}
%define rel	1suse10
%define gtkhtml  libgtkhtml-3.8
%define bundledeps 0
%define	suse	1
%endif
%if %{rhel4}
%define rel      1rhel4
%define gtkhtml  libgtkhtml-2.0
%define bundledeps 1
%endif
%if %{rhel3}
%define rel      1rhel3
%define gtkhtml  libgtkhtml-2.0
%define bundledeps 1
%define gcc3 	1
%endif
%if %{fc5}
%define rel	1fc5
%define gtkhtml libgtkhtml-3.8
%define bundledeps 0
%endif


%if %{suse}
%define sysprefix /opt/gnome
%define sysconfdir /etc%{prefix}
%else
%define sysprefix %{_prefix}
%endif

Summary: GUI Tools for MySQL 5.0 - common files
Name: mysql-gui-tools
Group: Development/Databases
Version: %ver
Release: %rel
License: GPL
Source: %{name}-%{version}.tar.gz
BuildRoot: /var/tmp/mysql-gui-tools-%{PACKAGE_VERSION}-root

Source1: pangorc
Source2: pango.modules
Source3: gdk-pixbuf.loaders
Source4: ma-html-chapter.tar.gz
Source5: qb-html-chapter.tar.gz

Patch0: gcc3.dif

%description 
GUI Tools for MySQL 5.0 is a suite of applications written for developing
and managing MySQL servers. 

This package contains data files and libraries for MySQL GUI Tools.
Actual applications are in packages mysql-administrator, mysql-query-browser
and mysql-workbench

%package -n mysql-administrator
Summary: Administration tool for MySQL 5.0
Group: Development/Databases
Requires: mysql-gui-tools = %{ver}

%description -n mysql-administrator
MySQL Administrator is a powerful graphical administration console that
enables you to easily administer your MySQL environment and gain
significantly better visibility into how your databases are operating.
MySQL Administrator now integrates database management and maintenance
into a single, seamless environment, with a clear and intuitive graphical
user interface.

This is MySQL Administrator %{ma_realversion}.

%package -n mysql-query-browser
Summary: Query shell for MySQL 5.0
Group: Development/Databases
Requires: mysql-gui-tools = %{ver}

%description -n mysql-query-browser
MySQL Query Browser is a GUI tool for executing SQL queries.
It will display the result in a list where you can edit its contents
and save. It has several auxiliar features to facilitate work, such
as query "bookmarking", query history, syntax highlighting and online
help.

This is MySQL QueryBrowser %{qb_realversion}.

#%package -n mysql-workbench
#Summary: Extensible modeling tool for MySQL 5.0
#Group: Development/Databases
#Requires: mysql-gui-tools = %{ver}

#%description -n mysql-workbench
#MySQL Workbench is modeling tool that allows you to design
#and generate MySQL databases graphically.
#
#MySQL Workbench requires OpenGL and a 3D accelerated graphics card with
#at least 16MB of memory.
#
#This is MySQL Workbench %{wb_realversion}.

%if %{build_mt}
%package -n mysql-migration-toolkit
Summary: Experimental database migration tool for MySQL 5.0
Group: Development/Databases
Requires: mysql-gui-tools = %{ver}

%description -n mysql-migration-toolkit
MySQL Migration Toolkit is a framework for migrating databases from
various RDBMS to MySQL. The Linux version of the tool is a simpler,
text only version, but can be used to help migration of tables and data.
# build_mt
%endif


%prep

%setup -q -n %{name}-%{version}
%if %{?gcc3}
echo "gcc3!!!"
%patch0
%endif

%build

# gui-common
cd mysql-gui-common
if [ ! -f configure ]; then
  CFLAGS="$RPM_OPT_FLAGS" sh ./autogen.sh --prefix=%{_prefix} --sysconfdir=%{_sysconfdir}  --enable-grt --enable-canvas --enable-java-modules --with-java-includes="%{javaincdir}" --with-java-ldflags=-L%{javalibdir}
else
  CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} --sysconfdir=%{_sysconfdir} --enable-grt --enable-canvas --enable-java-modules --with-java-includes="%{javaincdir}" --with-java-ldflags=-L%{javalibdir}
fi
if [ "$SMP" != "" ]; then
  (make "MAKE=make -k -j $SMP"; exit 0)
  make
else
  make
fi


%if %{build_mt}
# migration tool
cd ../mysql-migration-tool
env LD_LIBRARY_PATH="$LD_LIBRARY_PATH:%{javalibdir}" ./build_mt_script.sh 
%endif


# administrator
cd ../mysql-administrator
if [ ! -f configure ]; then
  CFLAGS="$RPM_OPT_FLAGS" sh ./autogen.sh --prefix=%{_prefix} --sysconfdir=%{_sysconfdir} 
else
  CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} --sysconfdir=%{_sysconfdir}
fi
if [ "$SMP" != "" ]; then
  (make "MAKE=make -k -j $SMP"; exit 0)
  make
else
  make
fi

# query-browser
cd ../mysql-query-browser
if [ ! -f configure ]; then
  CFLAGS="$RPM_OPT_FLAGS" sh ./autogen.sh --prefix=%{_prefix} --sysconfdir=%{_sysconfdir}  --with-gtkhtml=%{gtkhtml}
else
  CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} --sysconfdir=%{_sysconfdir} --with-gtkhtml=%{gtkhtml}
fi
if [ "$SMP" != "" ]; then
  (make "MAKE=make -k -j $SMP"; exit 0)
  make
else
  make
fi

# workbench
#cd ../mysql-workbench
#if [ ! -f configure ]; then
#  CFLAGS="$RPM_OPT_FLAGS" sh ./autogen.sh --prefix=%{_prefix} --sysconfdir=%{_sysconfdir} 
#else
#  CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} --sysconfdir=%{_sysconfdir} 
#fi
#if [ "$SMP" != "" ]; then
#  (make "MAKE=make -k -j $SMP"; exit 0)
#  make
#else
#  make
#fi



%install
rm -rf %{buildroot}

cd mysql-gui-common
make -k DESTDIR=$RPM_BUILD_ROOT prefix=%{_prefix} localedir=$RPM_BUILD_ROOT%{_datadir}/locale install

if test %{_lib} == lib64; then
(cd $RPM_BUILD_ROOT; ln -s %{_lib}/mysql-gui lib/)
fi

cd ../mysql-administrator
make -k DESTDIR=$RPM_BUILD_ROOT prefix=%{_prefix} localedir=$RPM_BUILD_ROOT%{_datadir}/locale install
cd ../mysql-query-browser
make -k DESTDIR=$RPM_BUILD_ROOT prefix=%{_prefix} localedir=$RPM_BUILD_ROOT%{_datadir}/locale install
#cd ../mysql-workbench
#make -k DESTDIR=$RPM_BUILD_ROOT prefix=%{_prefix} localedir=$RPM_BUILD_ROOT%{_datadir}/locale install

%if %{build_mt}
cd ../mysql-migration-tool
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mysql-gui/migration-toolkit-script/
cp -a mysql-migration-toolkit-script-*/* $RPM_BUILD_ROOT%{_libdir}/mysql-gui/migration-toolkit-script/
%endif


# copy docs
mkdir -p $RPM_BUILD_ROOT%{_docdir}/administrator
tar xzf %{SOURCE4} -C $RPM_BUILD_ROOT%{_docdir}/administrator
mv $RPM_BUILD_ROOT%{_docdir}/administrator/html-chapter/* $RPM_BUILD_ROOT%{_docdir}/administrator
rmdir $RPM_BUILD_ROOT%{_docdir}/administrator/html-chapter

mkdir -p $RPM_BUILD_ROOT%{_docdir}/query-browser
tar xzf %{SOURCE5} -C $RPM_BUILD_ROOT%{_docdir}/query-browser
mv $RPM_BUILD_ROOT%{_docdir}/query-browser/html-chapter/* $RPM_BUILD_ROOT%{_docdir}/query-browser
rmdir $RPM_BUILD_ROOT%{_docdir}/query-browser/html-chapter



# bundle dependencies together
if [ %{bundledeps} -ne 0 ]; then
  mkdir -p $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib
  liblist=`ldd $RPM_BUILD_ROOT%{_prefix}/bin/*-bin | sort | uniq | grep '=>' | sed 's/\t[^\ ]*[\ ]*=>\?[\ ]*\([^\ ]*\).*/\1/' | sed s/^[^\/].*// | grep -v '^$'` 
  /bin/cp $liblist $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib
  /bin/rm -f $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/{libcrypt.so.*,libm.so.*,libc.so.*,libdl.so.*,libnsl.so.*,libz.so.*,libX*.so.*,libGL*.so.*,libfontconfig.so.*,libfreetype.so.*,libart_*.so.*,libpthread.so.*}

  cp %{SOURCE1} $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/
  cp %{SOURCE2} $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/
  cp %{SOURCE3} $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/

  mkdir -p $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/pango
  mkdir -p $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/gdk-pixbuf/loaders
  mkdir -p $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/engines
%if %{?suse}
  cp /opt/gnome/%{_lib}/gtk-2.0/2.4.0/loaders/lib*{xpm,gif,png,jpeg}.so $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/gdk-pixbuf/loaders/
  cp /opt/gnome/%{_lib}/pango/*/modules/pango-basic*.so $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/pango/
%else
  cp %{_libdir}/gtk-2.0/2.4.0/loaders/lib*{xpm,gif,png,jpeg}.so $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/gdk-pixbuf/loaders/
  cp %{_libdir}/gtk-2.0/2.4.0/engines/libbluecurve.so $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/engines/
  cp %{_libdir}/pango/*/modules/pango-basic*.so $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib/pango/
  (cd $RPM_BUILD_ROOT%{_libdir}/mysql-gui/lib; ln -s . gtk-2.0)
%endif
fi


if [ -f $RPM_BUILD_ROOT%{_prefix}/lib/mysql-gui/libmyx_grt_java.so.0.0.0 ]; then
# Remove some unused files so that rpmbuild won't complain
mv $RPM_BUILD_ROOT%{_prefix}/lib/mysql-gui/libmyx_grt_java.so.0.0.0 $RPM_BUILD_ROOT%{_libdir}/mysql-gui/libmyx_grt_java.so
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/mysql-gui/libmyx_grt_java.{a,la,so.0}
else
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mysql-gui/

# this is not needed if the mt is shipped in lib/mysql-gui/
%if %{build_mt}
%else
touch $RPM_BUILD_ROOT%{_libdir}/mysql-gui/dummy
%endif
fi


%clean
rm -rf %{buildroot}


%files 
%defattr(-, root, root)
%dir %{_datadir}/mysql-gui
%{_datadir}/mysql-gui/common/*
#%if %{build_mt}
#%else
#%{_libdir}/mysql-gui/lib/*
#%endif

%files -n mysql-administrator
%defattr(-, root, root)
%{_bindir}/mabackup
%{_bindir}/mysql-administrator
%{_bindir}/mysql-administrator-bin
%dir %{_datadir}/mysql-gui/administrator
%{_datadir}/mysql-gui/MySQLIcon_Admin*
%{_datadir}/mysql-gui/administrator/*
%{_datadir}/applications/MySQLAdministrator.desktop
%{_datadir}/locale/*/LC_MESSAGES/mysql-administrator.mo
%{_docdir}/administrator/*

%files -n mysql-query-browser
%defattr(-, root, root)
%dir %{_datadir}/mysql-gui/query-browser
%{_datadir}/mysql-gui/query-browser/*
%{_bindir}/mysql-query-browser
%{_bindir}/mysql-query-browser-bin
%{_datadir}/mysql-gui/MySQLIcon_Query*
%{_datadir}/applications/MySQLQueryBrowser.desktop
%{_datadir}/locale/*/LC_MESSAGES/mysql-query-browser.mo
%{_docdir}/query-browser/*

#%files -n mysql-workbench
#%defattr(-, root, root)
#%{_bindir}/mysql-workbench
#%{_bindir}/mysql-workbench-bin
#%dir %{_datadir}/mysql-gui/workbench
#%{_datadir}/mysql-gui/MySQLIcon_Workbench*
#%{_datadir}/mysql-gui/workbench/*
#%{_datadir}/applications/MySQLWorkbench.desktop

%if %{build_mt}
%files -n mysql-migration-toolkit
%defattr(-, root, root)
%{_libdir}/mysql-gui/migration-toolkit-script/*
%{_libdir}/mysql-gui/libmyx_grt_java.so
%endif

